-- Kranseil
--
-- M@D Author  Headshot XXL   &   Gorli
-- M@D date  29.04.2009
--
-- > Copyright (C) Headshot XXL & Gorli< --
-- > erweitert (C) 2011 Bauer Wolle< --

Kranseil = {}

function Kranseil.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Kranseil:load(xmlFile)
	
    local translationPartNode31 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart31#index"));
    if translationPartNode31 ~= nil then
        self.translationPart31 = {};
        self.translationPart31.node = translationPartNode31;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart31#minTrans"));
        self.translationPart31.minTrans = {};
        self.translationPart31.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart31.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart31.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart31#maxTrans"));
        self.translationPart31.maxTrans = {};
        self.translationPart31.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart31.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart31.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart31.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart31#transTime"), 2)*1000;
        self.translationPart31.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart31#touchTransLimit"), 10);
    end; 
    local translationPartNode32 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart32#index"));
    if translationPartNode32 ~= nil then
        self.translationPart32 = {};
        self.translationPart32.node = translationPartNode32;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart32#minTrans"));
        self.translationPart32.minTrans = {};
        self.translationPart32.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart32.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart32.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart32#maxTrans"));
        self.translationPart32.maxTrans = {};
        self.translationPart32.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart32.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart32.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart32.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart32#transTime"), 2)*1000;
        self.translationPart32.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart32#touchTransLimit"), 10);
    end; 
 
	local translationPartNode33 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart33#index"));
    if translationPartNode33 ~= nil then
        self.translationPart33 = {};
        self.translationPart33.node = translationPartNode33;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart33#minTrans"));
        self.translationPart33.minTrans = {};
        self.translationPart33.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart33.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart33.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart33#maxTrans"));
        self.translationPart33.maxTrans = {};
        self.translationPart33.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart33.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart33.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart33.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart33#transTime"), 2)*1000;
        self.translationPart33.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart33#touchTransLimit"), 10);
    end; 
    local translationPartNode34 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart34#index"));
    if translationPartNode34 ~= nil then
        self.translationPart34 = {};
        self.translationPart34.node = translationPartNode34;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart34#minTrans"));
        self.translationPart34.minTrans = {};
        self.translationPart34.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart34.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart34.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart34#maxTrans"));
        self.translationPart34.maxTrans = {};
        self.translationPart34.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart34.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart34.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart34.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart34#transTime"), 2)*1000;
        self.translationPart34.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart34#touchTransLimit"), 10);
    end; 
    local translationPartNode35 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart35#index"));
    if translationPartNode35 ~= nil then
        self.translationPart35 = {};
        self.translationPart35.node = translationPartNode35;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart35#minTrans"));
        self.translationPart35.minTrans = {};
        self.translationPart35.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart35.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart35.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart35#maxTrans"));
        self.translationPart35.maxTrans = {};
        self.translationPart35.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart35.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart35.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart35.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart35#transTime"), 2)*1000;
        self.translationPart35.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart35#touchTransLimit"), 10);
    end; 
	
    local translationPartNode36 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart36#index"));
    if translationPartNode36 ~= nil then
        self.translationPart36 = {};
        self.translationPart36.node = translationPartNode36;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart36#minTrans"));
        self.translationPart36.minTrans = {};
        self.translationPart36.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart36.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart36.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart36#maxTrans"));
        self.translationPart36.maxTrans = {};
        self.translationPart36.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart36.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart36.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart36.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart36#transTime"), 2)*1000;
        self.translationPart36.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart36#touchTransLimit"), 10);
    end; 
 
    local translationPartNode37 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart37#index"));
    if translationPartNode37 ~= nil then
        self.translationPart37 = {};
        self.translationPart37.node = translationPartNode37;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart37#minTrans"));
        self.translationPart37.minTrans = {};
        self.translationPart37.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart37.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart37.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart37#maxTrans"));
        self.translationPart37.maxTrans = {};
        self.translationPart37.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart37.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart37.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart37.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart37#transTime"), 2)*1000;
        self.translationPart37.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart37#touchTransLimit"), 10);
    end; 
    local translationPartNode38 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart38#index"));
    if translationPartNode38 ~= nil then
        self.translationPart38 = {};
        self.translationPart38.node = translationPartNode38;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart38#minTrans"));
        self.translationPart38.minTrans = {};
        self.translationPart38.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart38.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart38.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart38#maxTrans"));
        self.translationPart38.maxTrans = {};
        self.translationPart38.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart38.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart38.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart38.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart38#transTime"), 2)*1000;
        self.translationPart38.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart38#touchTransLimit"), 10);
    end; 
    local translationPartNode39 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart39#index"));
    if translationPartNode39 ~= nil then
        self.translationPart39 = {};
        self.translationPart39.node = translationPartNode39;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart39#minTrans"));
        self.translationPart39.minTrans = {};
        self.translationPart39.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart39.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart39.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart39#maxTrans"));
        self.translationPart39.maxTrans = {};
        self.translationPart39.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart39.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart39.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart39.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart39#transTime"), 2)*1000;
        self.translationPart39.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart39#touchTransLimit"), 10);
    end; 
        
    local translationPartNode40 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart40#index"));
    if translationPartNode40 ~= nil then
        self.translationPart40 = {};
        self.translationPart40.node = translationPartNode40;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart40#minTrans"));
        self.translationPart40.minTrans = {};
        self.translationPart40.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart40.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart40.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart40#maxTrans"));
        self.translationPart40.maxTrans = {};
        self.translationPart40.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart40.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart40.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart40.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart40#transTime"), 2)*1000;
        self.translationPart40.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart40#touchTransLimit"), 10);
    end; 
    local translationPartNode41 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart41#index"));
    if translationPartNode41 ~= nil then
        self.translationPart41 = {};
        self.translationPart41.node = translationPartNode41;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart41#minTrans"));
        self.translationPart41.minTrans = {};
        self.translationPart41.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart41.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart41.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart41#maxTrans"));
        self.translationPart41.maxTrans = {};
        self.translationPart41.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart41.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart41.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart41.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart41#transTime"), 2)*1000;
        self.translationPart41.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart41#touchTransLimit"), 10);
    end; 
 
    local translationPartNode42 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart42#index"));
    if translationPartNode42 ~= nil then
        self.translationPart42 = {};
        self.translationPart42.node = translationPartNode42;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart42#minTrans"));
        self.translationPart42.minTrans = {};
        self.translationPart42.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart42.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart42.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart42#maxTrans"));
        self.translationPart42.maxTrans = {};
        self.translationPart42.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart42.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart42.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart42.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart42#transTime"), 2)*1000;
        self.translationPart42.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart42#touchTransLimit"), 10);
    end; 
    local translationPartNode43 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart43#index"));
    if translationPartNode43 ~= nil then
        self.translationPart43 = {};
        self.translationPart43.node = translationPartNode43;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart43#minTrans"));
        self.translationPart43.minTrans = {};
        self.translationPart43.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart43.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart43.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart43#maxTrans"));
        self.translationPart43.maxTrans = {};
        self.translationPart43.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart43.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart43.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart43.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart43#transTime"), 2)*1000;
        self.translationPart43.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart43#touchTransLimit"), 10);
    end; 
    
   
    local rotationNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation11#index"));
    if rotationNode11 ~= nil then
        self.rotation11 = {};
        self.rotation11.node = rotationNode11;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#minRot"));
        self.rotation11.minRot = {};
        self.rotation11.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#maxRot"));
        self.rotation11.maxRot = {};
        self.rotation11.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation11.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#rotTime"), 2)*1000;
        self.rotation11.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#touchRotLimit"), 10));
    end;
	
    local rotationNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation12#index"));
    if rotationNode12 ~= nil then
        self.rotation12 = {};
        self.rotation12.node = rotationNode12;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#minRot"));
        self.rotation12.minRot = {};
        self.rotation12.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#maxRot"));
        self.rotation12.maxRot = {};
        self.rotation12.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation12.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#rotTime"), 2)*1000;
        self.rotation12.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#touchRotLimit"), 10));
    end;
    local rotationNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation13#index"));
    if rotationNode13 ~= nil then
        self.rotation13 = {};
        self.rotation13.node = rotationNode13;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#minRot"));
        self.rotation13.minRot = {};
        self.rotation13.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#maxRot"));
        self.rotation13.maxRot = {};
        self.rotation13.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation13.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#rotTime"), 2)*1000;
        self.rotation13.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#touchRotLimit"), 10));
    end;
    local rotationNode14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation14#index"));
    if rotationNode14 ~= nil then
        self.rotation14 = {};
        self.rotation14.node = rotationNode14;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#minRot"));
        self.rotation14.minRot = {};
        self.rotation14.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#maxRot"));
        self.rotation14.maxRot = {};
        self.rotation14.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation14.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#rotTime"), 2)*1000;
        self.rotation14.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#touchRotLimit"), 10));
    end;
end;
      
function Kranseil:delete()
end;

function Kranseil:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function Kranseil:keyEvent(unicode, sym, modifier, isDown)
if sym == Input.KEY_KP_9 then
		self.translationMax31 = isDown;
		self.translationMax32 = isDown;
                self.translationMax33 = isDown;
		self.translationMax34 = isDown;
                self.translationMax35 = isDown;
                self.translationMax36 = isDown;
		self.translationMax37 = isDown; 
                self.translationMax38 = isDown;
                self.translationMax39 = isDown; 
		self.translationMax40 = isDown; 
                self.translationMax41 = isDown;
		self.translationMax42 = isDown;
                self.translationMax43 = isDown;
	end;               

	if sym == Input.KEY_KP_6 then
		self.translationMin31 = isDown;
		self.translationMin32 = isDown;
                self.translationMin33 = isDown;
		self.translationMin34 = isDown;
                self.translationMin35 = isDown;               
		self.translationMin36 = isDown;
		self.translationMin37 = isDown;
                self.translationMin38 = isDown; 
                self.translationMin39 = isDown;
		self.translationMin40 = isDown;
                self.translationMin41 = isDown;
		self.translationMin42 = isDown;
                self.translationMin43 = isDown;
	end;  
   
       
        if sym == Input.KEY_KP_1 then
		self.rotation11Max = isDown;		
	end;
        if sym == Input.KEY_KP_3 then
		self.rotation11Min = isDown;
	end;
        if sym == Input.KEY_KP_7 then
		self.rotation12Max = isDown;		
	end;
        if sym == Input.KEY_KP_4 then
		self.rotation12Min = isDown;
	end;
        

	
        
       

end;      
  


function Kranseil:update(dt)
	
	local doTranslate = self.translationMax31 or self.translationMin31 
	if self.translationPart31 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart31.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart31.maxTrans, self.translationPart31.minTrans, 3, self.translationPart31.transTime, dt, not self.translationMax31); 
		setTranslation(self.translationPart31.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax32 or self.translationMin32 
	if self.translationPart32 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart32.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart32.maxTrans, self.translationPart32.minTrans, 3, self.translationPart32.transTime, dt, not self.translationMax32); 
		setTranslation(self.translationPart32.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax33 or self.translationMin33 
	if self.translationPart33 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart33.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart33.maxTrans, self.translationPart33.minTrans, 3, self.translationPart33.transTime, dt, not self.translationMax33); 
		setTranslation(self.translationPart33.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax34 or self.translationMin34 
	if self.translationPart34 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart34.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart34.maxTrans, self.translationPart34.minTrans, 3, self.translationPart34.transTime, dt, not self.translationMax34); 
		setTranslation(self.translationPart34.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax35 or self.translationMin35 
	if self.translationPart5 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart35.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart35.maxTrans, self.translationPart35.minTrans, 3, self.translationPart35.transTime, dt, not self.translationMax35); 
		setTranslation(self.translationPart35.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax36 or self.translationMin36 
	if self.translationPart36 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart36.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart36.maxTrans, self.translationPart36.minTrans, 3, self.translationPart36.transTime, dt, not self.translationMax36); 
		setTranslation(self.translationPart36.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax37 or self.translationMin37 
	if self.translationPart37 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart37.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart37.maxTrans, self.translationPart37.minTrans, 3, self.translationPart37.transTime, dt, not self.translationMax37); 
		setTranslation(self.translationPart37.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax38 or self.translationMin38 
	if self.translationPart38 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart38.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart38.maxTrans, self.translationPart38.minTrans, 3, self.translationPart38.transTime, dt, not self.translationMax38); 
		setTranslation(self.translationPart38.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax39 or self.translationMin39 
	if self.translationPart39 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart39.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart39.maxTrans, self.translationPart39.minTrans, 3, self.translationPart39.transTime, dt, not self.translationMax39); 
		setTranslation(self.translationPart39.node, unpack(newTrans)); 
	end;
             
        local doTranslate = self.translationMax40 or self.translationMin40 
	if self.translationPart40 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart40.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart40.maxTrans, self.translationPart40.minTrans, 3, self.translationPart40.transTime, dt, not self.translationMax40); 
		setTranslation(self.translationPart40.node, unpack(newTrans)); 
	end; 
        local doTranslate = self.translationMax41 or self.translationMin41 
	if self.translationPart41 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart41.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart41.maxTrans, self.translationPart41.minTrans, 3, self.translationPart41.transTime, dt, not self.translationMax41); 
		setTranslation(self.translationPart41.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax42 or self.translationMin42 
	if self.translationPart42 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart42.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart42.maxTrans, self.translationPart42.minTrans, 3, self.translationPart42.transTime, dt, not self.translationMax42); 
		setTranslation(self.translationPart42.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax43 or self.translationMin43 
	if self.translationPart43 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart43.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart43.maxTrans, self.translationPart43.minTrans, 3, self.translationPart43.transTime, dt, not self.translationMax43); 
		setTranslation(self.translationPart43.node, unpack(newTrans)); 
	end; 
	
        
	local doRotate = self.rotation11Max or self.rotation11Min 
	if self.rotation11 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation11.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation11.maxRot, self.rotation11.minRot, 3, self.rotation11.rotTime, dt, not self.rotation11Max);
        setRotation(self.rotation11.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation12Max or self.rotation12Min 
	if self.rotation12 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation12.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation12.maxRot, self.rotation12.minRot, 3, self.rotation12.rotTime, dt, not self.rotation12Max);
        setRotation(self.rotation12.node, unpack(newRot));
    end;
        local doRotate = self.rotation13Max or self.rotation13Min 
	if self.rotation13 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation13.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation13.maxRot, self.rotation13.minRot, 3, self.rotation13.rotTime, dt, not self.rotation13Max);
        setRotation(self.rotation13.node, unpack(newRot));
    end;
        local doRotate = self.rotation14Max or self.rotation14Min
	if self.rotation14 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation14.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation14.maxRot, self.rotation14.minRot, 3, self.rotation14.rotTime, dt, not self.rotation14Max);
        setRotation(self.rotation14.node, unpack(newRot));
    end;
end;

function Kranseil:draw()
end;

function Kranseil:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
